Page MenuHomePhabricator

[AMDGPU] Increases available SGPR for Calling Convention
ClosedPublic

Authored by rtaylor on Apr 29 2019, 7:11 AM.

Details

Summary

SGPR in CC can be either hw initialized or set by other chained shaders
and so this increases the SGPR count availalbe to CC to 104.

Change-Id: I3dfadc750fe4a3e2bd07117a2899fd13f3e2fef3

Diff Detail

Repository
rL LLVM

Event Timeline

rtaylor created this revision.Apr 29 2019, 7:11 AM
Herald added a project: Restricted Project. · View Herald TranscriptApr 29 2019, 7:11 AM
arsenm added inline comments.Apr 29 2019, 11:49 AM
lib/Target/AMDGPU/AMDGPUCallingConv.td
34 ↗(On Diff #197106)

I think this goes up to sgpr105 now

64 ↗(On Diff #197106)

The test doesn't cover this

rtaylor updated this revision to Diff 197363.Apr 30 2019, 9:59 AM

[AMDGPU] Increased SGPR Count for Calling Convention

Up the sgpr count to 105 and included test case covers both in and return arguments

arsenm added inline comments.May 2 2019, 4:36 AM
lib/Target/AMDGPU/AMDGPUCallingConv.td
35 ↗(On Diff #197363)

It's up to SGPR105, not 105 SGPRs. SGPR105 should also be included

40–41 ↗(On Diff #197363)

I think this needs more work. I think allocateSGPRTuple hard codes the limit as well

rtaylor updated this revision to Diff 197824.May 2 2019, 10:33 AM

Fixed 105 SGPR to 106 SGPR, increased limit count for allocateSGPRTuple

LGTM, though I would like another test with i64 to make sure the SGPR tuple thing works

rtaylor updated this revision to Diff 199037.May 10 2019, 10:49 AM

Added test for SGPR tuple

This revision is now accepted and ready to land.May 14 2019, 6:01 AM
This revision was automatically updated to reflect the committed changes.